from pepperbot import PepperBot
from pepperbot.store.meta import BotRoute

from apps.wuhu_takeoff import WuHuTakeoff
from apps.riic_report_analysis import RIICReportAnalysis


bot = PepperBot(port=5800)
bot.register_adapter(
    bot_protocol="onebot",
    receive_protocol="websocket",
    backend_protocol="http",
    backend_host="127.0.0.1",
    backend_port=5700,
)

bot.apply_routes(
    [
        BotRoute(
            groups="*",
            friends=None,
            handlers=[WuHuTakeoff],
        ),
        BotRoute(
            groups={
                "onebot": [
                    "810857924",  # 测试群
                    "239200680",  # mower 1群
                    "838353939",  # mower 2群
                ]
            },
            friends=None,
            handlers=[RIICReportAnalysis],
        ),
    ]
)


if __name__ == "__main__":
    bot.run()
